Foreman - Bug #14253

Saving dashboard widget positions fails under Rails 4.2
03/17/2016 12:44 PM - Dominic Cleal

Status: Closed
Priority: Normal
Assignee: Dominic Cleal
Category: Dashboard
Target version: 1.11.1
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p

ull/3344,

https://github.com/theforeman/foreman_

openscap/pull/168

Description
Under Rails 4.2, the dashboard widget save button fails as it's attempting to do mass-assignment:

2016-03-17T16:29:06 [app] [I] Started POST "/widgets/save_positions" for 127.0.0.1 at 2016-03-17 1

6:29:06 +0000

2016-03-17T16:29:06 [app] [I] Processing by DashboardController#save_positions as JSON

2016-03-17T16:29:06 [app] I[I] Parameters: {"widgets"=>{"131"=>{"hide"=>"false", "col"=>"1", "row

"=>"1", "sizex"=>"8", "sizey"=>"1"}, "132"=>{"hide"=>"false", "col"=>"9", "row"=>"1", "sizex"=>"4"
"sizey"=>"1"}, "133"=>{"hide"=>"false", "col"=>"1", "row"=>"2", "sizex"=>

"e", "sizey"=>"1"}, "134"=>{"hide"=>"false", "col"=>"7", "row"=>"2", "sizex"=>"6", "sizey"=>"1"}}}

2016-03-17T16:29:06 [sgl] [D] ActiveRecord: :SessionStore: :Session Load (0.1lms) SELECT "session
s".* FROM "sessions" WHERE "sessions"."session_id" = ? ORDER BY "sessions"."id" ASC LIMIT 1 [["s
ession_id", "455ee386086b45496e75214£fc3334d15"]]

2016-03-17T16:29:06 [sgl] [D] User Load (0.1lms) SELECT "users".* FROM "users" WHERE "users"."i
d" = ? LIMIT 1 [["id", 24]]

2016-03-17T16:29:06 [app] [D] Setting current user thread-local variable to admin
2016-03-17T16:29:06 [sgl] [D] Setting Load (0.1lms) SELECT "settings".* FROM "settings" WHERE "
settings"."name" = ? ORDER BY "settings"."name" ASC LIMIT 1 [["name", "authorize_login_delegatio
n_api"]]

2016-03-17T16:29:06 [sgl] [D] AuthSource Load (0.1lms) SELECT "auth_sources".* FROM "auth_sourc
es" WHERE "auth_sources"."id" = ? LIMIT 1 [["id", 1]]

2016-03-17T16:29:06 [sgl] [D] Widget Load (0.2ms) SELECT "widgets".* FROM "widgets" WHERE "wid
gets"."user_id" = ? AND (id = 131) ORDER BY "widgets"."id" ASC LIMIT 1 [["user_id", 24]]
2016-03-17T16:29:06 [sqgl] [D] (0.2ms) Dbegin transaction

2016-03-17T16:29:06 [sgl] [D] (0.1ms) rollback transaction

2016-03-17T16:29:06 [app] [W] Failed to save positions

| ActiveModel: :ForbiddenAttributesError: ActiveModel::ForbiddenAttributesError

| /home/dcleal/.rvm/gems/ruby-2.0.0-p353@foreman/gems/activemodel-4.2.6/1lib/active_model/forbidde
n_attributes_protection.rb:21:1in “sanitize_for_mass_assignment'

| /home/dcleal/.rvm/gems/ruby-2.0.0-p353@foreman/gems/protected_attributes-1.1.3/1ib/active_model
/mass_assignment_security.rb:354:in “sanitize_for_mass_assignment'

| /home/dcleal/.rvm/gems/ruby-2.0.0-p353@foreman/gems/protected_attributes-1.1.3/1ib/active_recor
d/mass_assignment_security/attribute_assignment.rb:58:in “assign_attributes'

| /home/dcleal/.rvm/gems/ruby-2.0.0-p353@foreman/gems/protected_attributes-1.1.3/1lib/active_recor
d/mass_assignment_security/persistence.rb:64:in “block in update’

| /home/dcleal/.rvm/gems/ruby—-2.0.0-p353@foreman/gems/activerecord-4.2.6/1ib/active_record/transa
ctions.rb:351:1in “block in with_transaction_returning_status'

| /home/dcleal/.rvm/gems/ruby-2.0.0-p353@foreman/gems/activerecord-4.2.6/1ib/active_record/connec
tion_adapters/abstract/database_statements.rb:213:in "block in transaction'

| /home/dcleal/.rvm/gems/ruby-2.0.0-p353@foreman/gems/activerecord-4.2.6/1ib/active_record/connec
tion_adapters/abstract/transaction.rb:184:in ‘within_new_transaction'

| /home/dcleal/.rvm/gems/ruby-2.0.0-p353@foreman/gems/activerecord-4.2.6/1ib/active_record/connec
tion_adapters/abstract/database_statements.rb:213:in "transaction'

| /home/dcleal/.rvm/gems/ruby-2.0.0-p353@foreman/gems/activerecord-4.2.6/1ib/active_record/transa
ctions.rb:220:in "“transaction'

| /home/dcleal/.rvm/gems/ruby-2.0.0-p353@foreman/gems/activerecord-4.2.6/1ib/active_record/transa
ctions.rb:348:in “with_transaction_returning_status'

| /home/dcleal/.rvm/gems/ruby-2.0.0-p353@foreman/gems/protected_attributes-1.1.3/1ib/active_recor
d/mass_assignment_security/persistence.rb:63:in ‘update'

| /home/dcleal/code/foreman/foreman/app/controllers/dashboard_controller.rb:44:in “block in save_
positions'

| /home/dcleal/.rvm/gems/ruby-2.0.0-p353@foreman/gems/actionpack-4.2.6/1ib/action_controller/meta
1/strong_parameters.rb:185:in ‘each_pair'
| /home/dcleal/.rvm/gems/ruby-2.0.0-p353@foreman/gems/actionpack-4.2.6/1lib/action_controller/meta
1/strong_parameters.rb:185:in “each_pair'

| /home/dcleal/code/foreman/foreman/app/controllers/dashboard_controller.rb:42:in " save_positions

The Widget model doesn't have attr_accessible. This doesn't seem to affect develop with Rails 4.1, but 4.2 is stricter.

The dashboard controller is missing functional tests which would have caught this on the rails42 branch before now.

Related issues:

Related to Foreman - Bug #7568: Use attr_accessible for rails 4 upgrade Closed 09/22/2014
Related to Foreman - Feature #13244: Upgrade Ruby on Rails to 4.2 Closed 01/15/2016
Related to OpenSCAP - Bug #15001: Widgets on policy dashboard break the page Closed 05/11/2016

Associated revisions

Revision 38987e04 - 03/18/2016 11:00 AM - Dominic Cleal
fixes #14253 - add attr_accessible to Widget

Add position/view related attributes to widget as accessible attributes
and protect data such as template and name. Under Rail 4.2, saving the
dashboard was failing due to attribute protection, so new functional
tests cover the whole controller.

Revision dd543c2f - 04/18/2016 01:45 PM - Dominic Cleal

fixes #14253 - add attr_accessible to Widget

Add position/view related attributes to widget as accessible attributes

and protect data such as template and name. Under Rail 4.2, saving the
dashboard was failing due to attribute protection, so new functional

tests cover the whole controller.

(cherry picked from commit 38987e042c1bdd55b259ee6a7fa34403341c8d80)
Revision dc22dab3 - 05/11/2016 07:06 AM - Ondrej Prazak

Fixes #14253 - Avoid mass assignment for policy widgets

Revision 55401687 - 06/21/2016 08:09 AM - Marek Hulan
Merge pull request #168 from xprazak2/widg-attrs

Fixes #14253 - Avoid mass assignment for policy widgets

History

#1 - 03/18/2016 06:14 AM - Dominic Cleal
- Related to Bug #7568: Use attr_accessible for rails 4 upgrade added

#2 - 03/18/2016 06:14 AM - Dominic Cleal
- Related to Feature #13244: Upgrade Ruby on Rails to 4.2 added

#3 - 03/18/2016 06:15 AM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3344 added

#4 - 03/18/2016 11:02 AM - Dominic Cleal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 38987e042c1bdd55b259ee6a7fa34403341c8d80.

#5 - 03/21/2016 09:37 AM - Dominic Cleal

- translation missing: en.field_release set to 141

#6 - 05/11/2016 07:01 AM - Ondfej Prazak
- Related to Bug #15001: Widgets on policy dashboard break the page added

#7 - 05/11/2016 07:08 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman_openscap/pull/168 added
